// $Id: MigrationMsgs.h,v 1.14 2006/05/18 19:58:41 chien-liang Exp $

/* Servilla - A middleware for wireless sensor networks.
 * Copyright (C) 2007, Washington University in Saint Louis
 * By Chien-Liang Fok.
 *
 * Washington University states that Servilla is free software;
 * you can redistribute it and/or modify it under the terms of
 * the current version of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * Servilla is distributed in the hope that it will be useful, but
 * THERE ARE NO WARRANTIES, WHETHER ORAL OR WRITTEN, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
 *
 * YOU UNDERSTAND THAT SERVILLA IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. THERE ARE NO
 * WARRANTIES AND NO REPRESENTATION THAT SERVILLA IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER
 * PROPRIETARY RIGHTS.  THERE ARE NO WARRANTIES THAT SOFTWARE IS
 * FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS",
 * OR OTHER HARMFUL CODE.
 *
 * YOU ASSUME THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
 * INFORMATION GENERATED USING SOFTWARE. By using Servilla you agree to
 * indemnify, defend, and hold harmless WU, its employees, officers and
 * scripts from any and all claims, costs, or liabilities, including
 * attorneys fees and court costs at both the trial and appellate levels
 * for any loss, damage, or injury caused by your actions or actions of
 * your officers, servants, scripts or third parties acting on behalf or
 * under authorization from you, as a result of using Servilla.
 *
 * See the GNU Lesser General Public License for more details, which can
 * be found here: http://www.gnu.org/copyleft/lesser.html
 */

#ifndef __RELIABLE_MSG_RECEIVER_INCLUDED__
#define __RELIABLE_MSG_RECEIVER_INCLUDED__

#ifndef RNI_RCV_BUFF_SIZE
#define RNI_RCV_BUFF_SIZE 5
#endif

#ifndef RNI_FIN_TIMER_PERIOD
#define RNI_FIN_TIMER_PERIOD 250
#endif

#ifndef RNI_ABORT_TIMER_PERIOD
#define RNI_ABORT_TIMER_PERIOD 2000
#endif

//-----------------------------------------------------------------------------
// Define global structures
struct BufferedData {
	uint16_t replyAddr;
	memsize_t size;
	vaddr_t vaddr;
	uint8_t am;
	bool used;
	bool finished;		// for timing out messages
	bool old;
} rbuf[RNI_RCV_BUFF_SIZE];

//-----------------------------------------------------------------------------
// Define other global variables


#endif
