#ifndef __RELIABLE_MESSAGES_INCLUDED__
#define __RELIABLE_MESSAGES_INCLUDED__

//-----------------------------------------------------------------------------
// Define global structures

#ifndef RMSG_SIZE
#define RMSG_SIZE 15
#endif

#include "../MemMgr.h"

enum {
	AM_RMSG			= 0xaa,
	AM_RACKMSG		= 0xab,
};
	
typedef struct RMsg {
	uint16_t replyAddr;
	memsize_t startAddr;   			// The starting address of the data
	memsize_t size;					// The total number of bytes
	uint8_t am;						// The active message type
	uint8_t data[RMSG_SIZE];		// The actual data being sent
} __attribute((packed)) RMsg;

typedef struct RAckMsg {
	uint16_t result;		// Either SUCCESS or FAIL
	memsize_t startAddr;	// The starting address of the data that is being acknowledged
	uint8_t am;				// The type of message
} __attribute((packed)) RAckMsg;

typedef struct RMsg_t{	// this is used to cache reliable messages
	uint16_t dest;
	vaddr_t vaddr;
	memsize_t size;
	uint8_t type;
} __attribute((packed)) RMsg_t;

typedef RMsg_t *RMsgPtr;

#endif
