
close all;
clear all;
clc;

%Looking at time histories

load ('test_11.mat');

data_x=data.datax;

data_y=data.datay;

data_z=data.dataz;


S1=data_x;
figure(1)
subplot(2,1,1)
plot(S1);grid on;
title('Time History S1')
xlabel('Data ID No.')
ylabel('Amplitude')

S2=data_y;
figure(2)
subplot(2,1,1)
plot(S2);grid on;
title('Time History S2')
xlabel('Data ID No.')
ylabel('Amplitude')

S3=data_z;
figure(3)
subplot(2,1,1)
plot(S3);grid on;
title('Time History S3')
xlabel('Data ID No.')
ylabel('Amplitude')

% S4=VCAP_DATA(1:256,1);
% figure(4)
% subplot(2,1,1)
% plot(S4);grid on;
% title('Time History S4')
% xlabel('Data ID No.')
% ylabel('Amplitude')
% 
% S5=VCAP_DATA(1:256,1);
% figure(5)
% subplot(2,1,1)
% plot(S5);grid on;
% title('Time History S5')
% xlabel('Data ID No.')
% ylabel('Amplitude')

%Fourier Transform
MS1 = fft(S1);
MS2 = fft(S2);
MS3 = fft(S3);

NS1 = length(S1);
NS2 = length(S2);
NS3 = length(S3);

Fs = 288; %hz
fS1 = [0:(NS1-1)] /NS1*Fs;

fS2 = [0:(NS2-1)] /NS2*Fs;
fS3 = [0:(NS3-1)] /NS3*Fs;
ffS3=fS3';


%Power Spectrum
PS1 = (MS1.*conj(MS1))./length(MS1);
PS2 = (MS2.*conj(MS2))./length(MS2);
PS3 = (MS3.*conj(MS3))./length(MS3);

%Adjusting (Destroying Mirror)
fS1 = fS1(1:NS1/2);
PS1 = PS1(1:NS1/2);

fS2 = fS2(1:NS2/2);
PS2 = PS2(1:NS2/2);

fS3 = fS3(1:NS3/2);
PS3 = PS3(1:NS3/2);

figure(1)
subplot(2,1,2)
plot(fS1,db(PS1));grid on;hold on;
title('Power Spectrum S1')
xlabel('Frequency (Hz)')
ylabel('Amplitude')

figure(2)
subplot(2,1,2)
plot(fS2,db(PS2));grid on;hold on;
title('Power Spectrum S2')
xlabel('Frequency (Hz)')
ylabel('Amplitude')

figure(3)
subplot(2,1,2)
plot(fS3,db(PS3));grid on;hold on;
title('Power Spectrum S3')
xlabel('Frequency (Hz)')
ylabel('Amplitude')

% tracking data loss
% figure(100)
% plot(S1(:,1),'r'); hold on;
% plot(S2(:,1),'b'); hold on;
% plot(S3(:,1),'g'); hold on;

%Curve-fitting
for yy = 1:3,
    if yy == 1,
        PXXa = PS1;
        f = fS1;
    end
    if yy == 2,
        PXXa = PS2;
        f = fS2;
    end
    if yy == 3,
        PXXa = PS3;
        f = fS3;
    end
for tt = 1:5,
    if tt == 1,
        st = find(f >= .01,1,'first');
        st1=st
        sp = find(f >= 3,1,'first');
        sp1=sp
    end
    if tt == 2,
        st = find(f >= 2,1,'first');
        st2=st
        sp = find(f >= 6,1,'first');
        sp2=sp
    end
    if tt == 3,
        st = find(f >= 9,1,'first');
        st3=st
        sp = find(f >= 18,1,'first');
        sp3=sp
    end
    if tt == 4,
        st = find(f >= 18,1,'first');
        st4=st
        sp = find(f >= 28,1,'first');
        sp4=sp
    end
    if tt == 5,
        st = find(f >= 28,1,'first');
        st5=st
        sp = find(f >= 40,1,'first');
        sp5=sp
    end

PXX = (PXXa(st:sp));
W = f(st:sp)*2*pi;

% % %Curve Fitting by Levi
%Second Order Numerator and Denominator Polynomials
y0 = 0;y2 = 0;y4 = 0;
t1 = 0;t3 = 0;
s0 = 0;s2 = 0;s4 = 0;
u2 = 0;u4 = 0;

for ii = 1:length(W),    
y0 = y0 + (W(ii))^0;
y2 = y2 + (W(ii))^2;
y4 = y4 + (W(ii))^4;

t1 = t1 + imag(PXX(ii))*(W(ii))^1;
t3 = t3 + imag(PXX(ii))*(W(ii))^3;


s0 = s0 + real(PXX(ii))*(W(ii))^0;
s2 = s2 + real(PXX(ii))*(W(ii))^2;
s4 = s4 + real(PXX(ii))*(W(ii))^4;

u2 = u2 + abs(PXX(ii))^2*(W(ii))^2;
u4 = u4 + abs(PXX(ii))^2*(W(ii))^4;

end

M = [y0 0 -y2 t1 s2;
    0 y2 0 -s2 t3;
    y2 0 -y4 t3 s4;
    t1 -s2 -t3 u2 0;
    s2 t3 -s4 0 u4];

C = [s0 t1 s2 0 u2]';
NN = inv(M)*C;

A = NN(1:3)';
B = [1; NN(4:5)]';
Q = [NN(5) NN(4) 1];


for jj = 1:length(W),
EPxx(jj) = (A(1) + A(2)*(i*W(jj)) + A(3)*(i*W(jj)).^2)./...
    (B(1) + B(2)*(i*W(jj)) + B(3)*(i*W(jj)).^2);
end

eval(['EPxx_',num2str(tt),' = EPxx;']);
eval(['W_',num2str(tt),' = W;']);

Wn(:,tt) = roots(Q)/2/pi/i;
clear EPxx
end

figure(yy)
subplot(2,1,2)
g = 1;
plot(W_1/2/pi,db(EPxx_1)*g,'r'); hold on;
plot(W_2/2/pi,db(EPxx_2)*g,'r'); hold on;
plot(W_3/2/pi,db(EPxx_3)*g,'r'); hold on;
plot(W_4/2/pi,db(EPxx_4)*g,'r'); hold on;
plot(W_5/2/pi,db(EPxx_5)*g,'r'); hold on;
Wn
end
