function sampleRecord = shm(fileName)
    sampleRecord = openRawData(fileName);
    
    Fs = sampleRecord.sampleHeader.samplingRate; 
            
    f = figure(1);
    clf;
    set(f, 'Name', 'X-Axis');
    data = sampleRecord.datax * sampleRecord.sampleHeader.ADCScale + sampleRecord.sampleHeader.ADCOffset;
    f = (0:length(data)-1) * Fs/length(data);
	t = (0:length(data)-1)/Fs;
	subplot(2,1,1); plot(t,data);
    xlabel('Time [s]');
    ylabel('Amplitude [V]');
    title('Time Domain Waveform');
  
    fdatax = fft(hamming(length(data)).*data);
    Fs = sampleRecord.sampleHeader.samplingRate;
    f = (0:length(data)-1) * Fs/length(data);
    subplot(2,1,2),plot(f,20*log10(abs(fdatax)/length(data)));
    title('Frequency Domain Waveform after Hamming Window');
    xlabel('Frequency [Hz]');
    ylabel('Amplitude [dBV]');
    
    
    f = figure(2);
    clf;
    set(f, 'Name', 'Y-Axis');
    data = sampleRecord.datay * sampleRecord.sampleHeader.ADCScale + sampleRecord.sampleHeader.ADCOffset;
    f = (0:length(data)-1) * Fs/length(data);
	t = (0:length(data)-1)/Fs;
	subplot(2,1,1); plot(t,data);
    xlabel('Time [s]');
    ylabel('Amplitude [V]');
    title('Time Domain Waveform');
  
    fdatax = fft(hamming(length(data)).*data);
    Fs = sampleRecord.sampleHeader.samplingRate;
    f = (0:length(data)-1) * Fs/length(data);
    subplot(2,1,2),plot(f,20*log10(abs(fdatax)/length(data)));
    title('Frequency Domain Waveform after Hamming Window');
    xlabel('Frequency [Hz]');
    ylabel('Amplitude [dBV]');
    
    f = figure(3);
    clf;
    set(f, 'Name', 'Z-Axis');
    data = sampleRecord.dataz * sampleRecord.sampleHeader.ADCScale + sampleRecord.sampleHeader.ADCOffset;
    f = (0:length(data)-1) * Fs/length(data);
	t = (0:length(data)-1)/Fs;
	subplot(2,1,1); plot(t,data);
    xlabel('Time [s]');
    ylabel('Amplitude [V]');
    title('Time Domain Waveform');
  
    fdatax = fft(hamming(length(data)).*data);
    Fs = sampleRecord.sampleHeader.samplingRate;
    f = (0:length(data)-1) * Fs/length(data);
    subplot(2,1,2),plot(f,20*log10(abs(fdatax)/length(data)));
    title('Frequency Domain Waveform after Hamming Window');
    xlabel('Frequency [Hz]');
    ylabel('Amplitude [dBV]');
    