package servilla;

public enum ErrorCodes {
	SERVILLA_ENGINE_ERROR,
	TYPE_CHECK,
	STACK_UNDERFLOW,
	STACK_OVERFLOW,
	AGENT_NOT_RUNNABLE,
	CODE_MGR_ERROR,
	MEMORY_MGR_ERROR,
	QUEUE_ERROR,
	QUEUE_ACCESS_VIOLATION,
	SEND_BUFFER_OVERFLOW,
	RCV_BUFFER_OVERFLOW,
	OPSTACK_ERROR,
	HEAP_ERROR,
	JUMP_ERROR,
	CALL_ERROR,
	OP_COMPARE_ERROR,
	OP_MIGRATE_ERROR,
	OP_SLEEP_ERROR,
	OP_STACK_ERROR,
	OP_HEAP_ERROR,
	OP_COND_ERROR,
	OP_NBR_ERROR,
	RECEIVER_COORD_ERROR,
	INVALID_INSTRUCTION,
	UNARY_MATH_ERROR,
	BINARY_MATH_ERROR,
	AGENT_SPEC_TABLE_ERROR,
	DEBUG_ERROR,			// an error code for debugging
	;
	
	static int counter = 0;
	
	static int nextCount() {
		return counter++;
	}
	
	int value;
	
	private ErrorCodes(){ //byte value) {
		//this.value = value;
		this.value = ErrorCodes.nextCount();
	}
	
	public int value() {
		return value;
	}
	
	public static String getName(int j) {
		ErrorCodes[] v = values();
		for (int i = 0; i < v.length; i++) {
			if (v[i].value() == j)
				return v[i].toString();
		}
		return "UNKNOWN ERROR";
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		/*try {
			Class c = Class.forName("servilla.compiler.tree.ISA");
			java.lang.reflect.Field[] fields = c.getDeclaredFields();
			for (int i = 0; i < fields.length; i++) {
					System.out.println(fields[i].getName());
			}
		} catch(Exception e) {
			e.printStackTrace();
		}*/
		ErrorCodes[] v = ErrorCodes.values();
		System.out.println("// This was automatically generated by servilla.ErrorCodes");
		System.out.println("// Copy this into shared/ErrMgr.h");
		System.out.println("// Total # error codes: " + v.length);
		System.out.println("typedef enum {");
		for (int i = 0; i < v.length; i++) {
			System.out.println("\t" + v[i] + " = "+ v[i].value() + ",");
		}
		System.out.println("} ErrorCodes;");	
	}
}
