// $Id: ErrorDisplayer.java,v 1.4 2005/12/21 17:13:43 chien-liang Exp $
/* Servilla - A middleware for wireless sensor networks.
 * Copyright (C) 2004, Washington University in Saint Louis
 * By Chien-Liang Fok.
 *
 * Washington University states that Servilla is free software;
 * you can redistribute it and/or modify it under the terms of
 * the current version of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * Servilla is distributed in the hope that it will be useful, but
 * THERE ARE NO WARRANTIES, WHETHER ORAL OR WRITTEN, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
 *
 * YOU UNDERSTAND THAT AGILLA IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. THERE ARE NO
 * WARRANTIES AND NO REPRESENTATION THAT AGILLA IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER
 * PROPRIETARY RIGHTS.  THERE ARE NO WARRANTIES THAT SOFTWARE IS
 * FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS",
 * OR OTHER HARMFUL CODE.
 *
 * YOU ASSUME THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
 * INFORMATION GENERATED USING SOFTWARE. By using Servilla you agree to
 * indemnify, defend, and hold harmless WU, its employees, officers and
 * scripts from any and all claims, costs, or liabilities, including
 * attorneys fees and court costs at both the trial and appellate levels
 * for any loss, damage, or injury caused by your actions or actions of
 * your officers, servants, scripts or third parties acting on behalf or
 * under authorization from you, as a result of using Servilla.
 *
 * See the GNU Lesser General Public License for more details, which can
 * be found here: http://www.gnu.org/copyleft/lesser.html
 */
package servilla;

import servilla.msgs.*;
import servilla.network.*;

import java.awt.*;

/**
 * ServillaErrorDisplayer.java
 *
 * @author Chien-Liang Fok
 */
public class ErrorDisplayer implements ServillaConstants, MessageListenerJ {
    private ErrorDialog dialog = null;
   
    ServillaErrorMsgJ msg;
	
	/**
	 * The constructor.
	 */
	public ErrorDisplayer(SNI sni) { sni.registerListener(new ServillaErrorMsgJ(), this);}
	
	private void updateDialog(ServillaErrorMsgJ msg) {
		Point p = null;
		if (dialog != null) {
			p = dialog.getLocation();
			dialog.dispose();
		}
		
		dialog = DialogFactory.errorDialog(msg);
		if (p != null) {
			dialog.setLocation(p);
		}
		
		dialog.show();
	}
	
	
	private void displayErrorMsg(ServillaErrorMsgJ msg) {
		boolean isNew = false;
		if (this.msg == null) {
			this.msg = msg;
			isNew = true;
		} else
			isNew = (this.msg.equals(msg));
		
		if (isNew) {
			System.out.println(msg);
			updateDialog(msg);
		}
	}
	
	
	public void messageReceived(int to, MessageJ msg) {
		if (msg.getType() == ServillaErrorMsg.AM_TYPE)
			displayErrorMsg((ServillaErrorMsgJ)msg);
	}
}

