package servilla;

import servilla.network.*;
import servilla.msgs.*;

/**
 * Periodically send a ServillaGatewayMsg to the mote attached to the PC.
 * This is to notify it that it is a gateway.  The message is sent every
 * five seconds.
 * 
 * @author Chien-Liang Fok
 */
public class HeartBeat implements ServillaConstants, Runnable {
	private SNI sni;
	private GWMsgJ bsMsg = new GWMsgJ();
	
	/**
	 * Creates a heart beat.
	 * 
	 * @param main The main servilla class.  This is needed for HeartBeat
	 * to access the sensor network interface (SNInterface).
	 */
	public HeartBeat(SNI sni) {
		this.sni = sni;
		new Thread(this).start();
	}
	
	public void run () {
		while(true) {
			try {
				sni.send(TOS_BCAST_ADDRESS, bsMsg);
				Thread.sleep(5000);
			} catch(Exception e) {
				e.printStackTrace();
			}
		}
	}
}
