package servilla;

import java.util.Vector;

import servilla.msgs.ServillaNbrMsgJ;
import servilla.network.*;


public class NeighborListQuerier implements MessageListenerJ {
	private QueryNbrListTimer nbrTimer;
	private Object nbrLock = new Object();
	private Vector<Address> nbrMsgs;
	
	public NeighborListQuerier(SNI sni) {
		sni.registerListener(new ServillaNbrMsgJ(), this);
	}
	/**
	 * Queries the neighbor list of a script.
	 *
	 * @param addr The address of the mote whose neighbor list is being queried.
	 * @return A vector containing the addresses within the mote's neighbor list.
	 * The addresses are stored as Address objects.
	 */
	public Vector<Address> queryNbrList(int addr) {
//		try {
//			ServillaGetNbrMsgJ msg = new ServillaGetNbrMsgJ(TOS_UART_ADDRESS, addr);
//			nbrMsgs = new Vector<Address>();
//			sni.send(TOS_BCAST_ADDRESS, msg);
//			nbrTimer = new QueryNbrListTimer(nbrLock);
//		    synchronized(nbrLock) {
//				nbrLock.wait();
//		    }
//		} catch(Exception ie) {
//		    ie.printStackTrace();
//		}
//		return nbrMsgs;
		return null;
	}
	
	private class QueryNbrListTimer implements Runnable {
		private static final int QUERY_NEIGHBOR_LIST_TIMER = 1000;
		private Object lock;
		private boolean alive = true;
		
		public QueryNbrListTimer(Object lock) {
		    this.lock = lock;
		    new Thread(this).start();
		}
		
		public void kill() {
			alive = false;
		}
		
		public void run () {
		    try {
				Thread.sleep(QUERY_NEIGHBOR_LIST_TIMER);
		    } catch(Exception e) {
				e.printStackTrace();
		    }
		    if (alive) {
				synchronized(lock) {
					lock.notify();
				}
		    }
		}
	}

	public void messageReceived(int dest, MessageJ msg) {
		// TODO Auto-generated method stub
		
	}
}
