package servilla;

import java.util.StringTokenizer;

public class NesCWriter {
	/** 
	 * Converts a byte array string into a valid NesC array declaration.
	 * 
	 * @param bas The byte array string
	 * @param arrayName The name of the array.
	 * @return NesC code.
	 */
	public static String byteArray(String bas, String arrayName) {
		StringTokenizer st = new StringTokenizer(bas);
		StringBuffer result = new StringBuffer();
		result.append("uint8_t " + arrayName + "[] = {\n\t");
		int count = 0;
		while (st.hasMoreTokens()) {
			result.append(st.nextToken());
			if (st.hasMoreTokens()) {
				result.append(", ");
				if(count++ == 9) {
					result.append("\n\t");
					count = 0;
				}
			}
		}
		result.append("\n};");
		return result.toString();
	}
}
