// $Id: ServillaConstants.java,v 1.4 2005/12/09 07:24:06 chien-liang Exp $

/* Servilla - A middleware for wireless sensor networks.
 * Copyright (C) 2004, Washington University in Saint Louis
 * By Chien-Liang Fok.
 *
 * Washington University states that Servilla is free software;
 * you can redistribute it and/or modify it under the terms of
 * the current version of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * Servilla is distributed in the hope that it will be useful, but
 * THERE ARE NO WARRANTIES, WHETHER ORAL OR WRITTEN, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
 *
 * YOU UNDERSTAND THAT AGILLA IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. THERE ARE NO
 * WARRANTIES AND NO REPRESENTATION THAT AGILLA IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER
 * PROPRIETARY RIGHTS.  THERE ARE NO WARRANTIES THAT SOFTWARE IS
 * FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS",
 * OR OTHER HARMFUL CODE.
 *
 * YOU ASSUME THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
 * INFORMATION GENERATED USING SOFTWARE. By using Servilla you agree to
 * indemnify, defend, and hold harmless WU, its employees, officers and
 * scripts from any and all claims, costs, or liabilities, including
 * attorneys fees and court costs at both the trial and appellate levels
 * for any loss, damage, or injury caused by your actions or actions of
 * your officers, servants, scripts or third parties acting on behalf or
 * under authorization from you, as a result of using Servilla.
 *
 * See the GNU Lesser General Public License for more details, which can
 * be found here: http://www.gnu.org/copyleft/lesser.html
 */
package servilla;

public interface ServillaConstants {
	static final short SUCCESS = 1;
	static final short FAIL = 0;
	
	static final int MAX_STRING_LENGTH=100;
	
	// address constants
	static final int TOS_BASE_ADDRESS = 0;  // address of mote attached to base station
	static final int TOS_UART_ADDRESS  = 0x007e;
	static final int TOS_LOCAL_ADDRESS = TOS_UART_ADDRESS; //0x0000;
	static final int TOS_BCAST_ADDRESS = 0xffff;
	
	// Script Migration Results
	static final short SERVILLA_INSUFFICIENT_MEMORY = 0;			// this must match those defined in MigrationMsgs.h
	static final short SERVILLA_DUPLICATE = 1;
	static final short SERVILLA_MESSAGE_LOSS = 2;
	static final short SERVILLA_ACCEPT = 3;
	
	// migration settings
	static final short RS_RETRY_PERIOD=128;
	static final short RS_MAX_RETRY_COUNT=3;
	static final short RS_MAX_RXMIT_COUNT=8;
	static final short RS_SNDR_RXMIT_TIMER_PERIOD=200;
	
	// This must match the constant defined in the ScriptSpecTable
	static final int SST_SPEC_OFFSET=9;
}

