// $Id: ServillaProperties.java,v 1.7 2005/12/19 23:06:25 chien-liang Exp $

/* Servilla - A middleware for wireless sensor networks.
 * Copyright (C) 2004, Washington University in Saint Louis
 * By Chien-Liang Fok.
 *
 * Washington University states that Servilla is free software;
 * you can redistribute it and/or modify it under the terms of
 * the current version of the GNU Lesser General Public License
 * as published by the Free Software Foundation.
 *
 * Servilla is distributed in the hope that it will be useful, but
 * THERE ARE NO WARRANTIES, WHETHER ORAL OR WRITTEN, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.
 *
 * YOU UNDERSTAND THAT AGILLA IS PROVIDED "AS IS" FOR WHICH NO
 * WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. THERE ARE NO
 * WARRANTIES AND NO REPRESENTATION THAT AGILLA IS FREE OF
 * INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER
 * PROPRIETARY RIGHTS.  THERE ARE NO WARRANTIES THAT SOFTWARE IS
 * FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS",
 * OR OTHER HARMFUL CODE.
 *
 * YOU ASSUME THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 * ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF
 * INFORMATION GENERATED USING SOFTWARE. By using Servilla you agree to
 * indemnify, defend, and hold harmless WU, its employees, officers and
 * scripts from any and all claims, costs, or liabilities, including
 * attorneys fees and court costs at both the trial and appellate levels
 * for any loss, damage, or injury caused by your actions or actions of
 * your officers, servants, scripts or third parties acting on behalf or
 * under authorization from you, as a result of using Servilla.
 *
 * See the GNU Lesser General Public License for more details, which can
 * be found here: http://www.gnu.org/copyleft/lesser.html
 */

package servilla;

import java.io.*;
import java.util.*;

public class ServillaProps extends Properties {
	static final long serialVersionUID = -4478107165233435498L;
	private static final ServillaProps singleton = new ServillaProps();
	
	private static final String DEFAULT_INIT_DIR = "/Users/liang/Research/Servilla/examples";
	private static final String DEFAULT_SCRIPT = "";
	private static final String DEFAULT_RS_MAX_RXMIT_COUNT="8";
	private static final String DEFAULT_RS_SNDR_RXMIT_TIMER_PERIOD="200";
	private static String initDir, defaultScript;
	private static int RS_MAX_RXMIT_COUNT, RS_SNDR_RXMIT_TIMER_PERIOD;
	
	private ServillaProps() {
		super();
		initDir = DEFAULT_INIT_DIR;
		defaultScript = DEFAULT_SCRIPT;
		RS_MAX_RXMIT_COUNT = Integer.valueOf(DEFAULT_RS_MAX_RXMIT_COUNT);
		RS_SNDR_RXMIT_TIMER_PERIOD = Integer.valueOf(DEFAULT_RS_SNDR_RXMIT_TIMER_PERIOD);
		try { load(new FileInputStream("servilla.properties")); } catch(IOException e) { return; }
		try {
			initDir = getProperty("initDir", DEFAULT_INIT_DIR);
			defaultScript = getProperty("defaultScript", DEFAULT_SCRIPT);
			RS_MAX_RXMIT_COUNT = Integer.valueOf(getProperty("RS_MAX_RXMIT_COUNT", DEFAULT_RS_MAX_RXMIT_COUNT));
			RS_SNDR_RXMIT_TIMER_PERIOD = Integer.valueOf(getProperty("RS_SNDR_RXMIT_TIMER_PERIOD", DEFAULT_RS_SNDR_RXMIT_TIMER_PERIOD));
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public String getInitDir() { return initDir; }
	
	public String defaultScript() { return defaultScript; }
	
	public int RS_MAX_RXMIT_COUNT() { return RS_MAX_RXMIT_COUNT; }
	
	public int RS_SNDR_RXMIT_TIMER_PERIOD() { return RS_SNDR_RXMIT_TIMER_PERIOD; }
	
	public static ServillaProps getProps() { return singleton; }	
}
