package servilla.compiler;
import java_cup.runtime.*;
import servilla.service.tree.DataType;
import servilla.compiler.tree.*;


class ServillaScriptYylex implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

  public String sourceFilename;
  private int prevState;
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yychar;
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	ServillaScriptYylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	ServillaScriptYylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private ServillaScriptYylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yychar = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int PARCOMMENT = 2;
	private final int LINECOMMENT = 1;
	private final int yy_state_dtrans[] = {
		0,
		59,
		61
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yychar = yychar
			+ yy_buffer_index - yy_buffer_start;
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NOT_ACCEPT,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NOT_ACCEPT,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NOT_ACCEPT,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NOT_ACCEPT,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NOT_ACCEPT,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NO_ANCHOR,
		/* 70 */ YY_NO_ANCHOR,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NO_ANCHOR,
		/* 73 */ YY_NO_ANCHOR,
		/* 74 */ YY_NO_ANCHOR,
		/* 75 */ YY_NO_ANCHOR,
		/* 76 */ YY_NO_ANCHOR,
		/* 77 */ YY_NO_ANCHOR,
		/* 78 */ YY_NO_ANCHOR,
		/* 79 */ YY_NO_ANCHOR,
		/* 80 */ YY_NO_ANCHOR,
		/* 81 */ YY_NO_ANCHOR,
		/* 82 */ YY_NO_ANCHOR,
		/* 83 */ YY_NO_ANCHOR,
		/* 84 */ YY_NO_ANCHOR,
		/* 85 */ YY_NO_ANCHOR,
		/* 86 */ YY_NO_ANCHOR,
		/* 87 */ YY_NO_ANCHOR,
		/* 88 */ YY_NO_ANCHOR,
		/* 89 */ YY_NO_ANCHOR,
		/* 90 */ YY_NO_ANCHOR,
		/* 91 */ YY_NO_ANCHOR,
		/* 92 */ YY_NO_ANCHOR,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NO_ANCHOR,
		/* 95 */ YY_NO_ANCHOR,
		/* 96 */ YY_NO_ANCHOR,
		/* 97 */ YY_NO_ANCHOR,
		/* 98 */ YY_NO_ANCHOR,
		/* 99 */ YY_NO_ANCHOR,
		/* 100 */ YY_NO_ANCHOR,
		/* 101 */ YY_NO_ANCHOR,
		/* 102 */ YY_NO_ANCHOR,
		/* 103 */ YY_NO_ANCHOR,
		/* 104 */ YY_NO_ANCHOR,
		/* 105 */ YY_NO_ANCHOR,
		/* 106 */ YY_NO_ANCHOR,
		/* 107 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"37:9,52,39,37,52,53,37:18,52,47,38,37:3,48,37,31,32,42,40,26,41,51,43,34,11" +
",18,17,33:2,12,33:3,37,25,44,46,45,37:2,36:6,50:20,29,37,30,37,13,37,16,21," +
"36,10,2,14,20,24,5,50,22,15,50,7,9,50,3,1,19,6,4,8,23,35,50:2,27,49,28,37:2" +
",0:2")[0];

	private int yy_rmap[] = unpackFromString(1,108,
"0,1,2,3,1:10,4,5,1,6,7,8,9,10,11,12,13,1:11,14,13:9,1:4,14,15,16,17,18,16,1" +
"9,17,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,4" +
"3,44,45,46,47,48,49,50,51,52,53,54,13,55,56,57,58,59,60,61,62,63,64,65,66,1" +
"3,67")[0];

	private int yy_nxt[][] = unpackFromString(68,54,
"1,2,80,106,107,51,106:2,81,106:2,3:2,106,69,106:2,3:2,82,106,83,106,91,106," +
"4,5,6,7,8,9,10,11,3,70,106:2,12,53,13,14,15,16,17,18,19,20,21,22,23,106,12," +
"13:2,-1:55,106,92,106:8,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93," +
"-1:3,50:10,3:2,50:4,3:2,50:14,3:2,50:4,-1,50:13,-1:41,26,-1:54,27,-1:54,28," +
"29,-1:56,30,-1:53,31,-1:53,32,-1:53,33,-1:55,34,-1:54,35,-1:5,106:10,93:2,1" +
"06:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:13,36:2,-1:4,36:2,-1:14,36:" +
"2,-1:20,106:6,95,106:3,93:2,106,24,106:2,93:2,106:6,-1:8,93:2,106:2,-1:13,1" +
"06,93,-1:4,52,-1:7,52:3,-1,52,-1,52:3,-1:2,52,-1:11,52:2,-1,52,-1:18,57:37," +
"25,57:15,-1:43,49,-1:11,37,106:9,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:1" +
"3,106,93,-1:3,106,38,106:8,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106," +
"93,-1:2,1,46:38,47,46:14,-1,106:9,39,93:2,106:4,93:2,106:6,-1:8,93:2,106:2," +
"-1:13,106,93,-1:2,1,48:41,54,48:11,-1,106:9,40,93:2,106:4,93:2,106:6,-1:8,9" +
"3:2,106:2,-1:13,106,93,-1:3,106:9,41,93:2,106:4,93:2,106:6,-1:8,93:2,106:2," +
"-1:13,106,93,-1:3,106,42,106:8,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13," +
"106,93,-1:3,106:6,43,106:3,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106," +
"93,-1:3,106,44,106:8,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:" +
"3,106,45,106:8,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:" +
"5,39,106:4,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:8,56" +
",106,93:2,106:2,96,106,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,50:10,3" +
":2,50:4,3:2,50:14,3:2,55,50:3,-1,50:13,-1:2,106:10,93:2,106:4,93:2,58,106:5" +
",-1:8,93:2,106:2,-1:13,106,93,-1:3,106:4,60,106:5,93:2,106:4,93:2,106:6,-1:" +
"8,93:2,106:2,-1:13,106,93,-1:3,106:6,62,106:3,93:2,106:4,93:2,106:6,-1:8,93" +
":2,106:2,-1:13,106,93,-1:3,106:6,63,106:3,93:2,106:4,93:2,106:6,-1:8,93:2,1" +
"06:2,-1:13,106,93,-1:3,106:10,93:2,106:2,64,106,93:2,106:6,-1:8,93:2,106:2," +
"-1:13,106,93,-1:3,65,106:9,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106," +
"93,-1:3,106:10,93:2,106:4,93:2,106:3,66,106:2,-1:8,93:2,106:2,-1:13,106,93," +
"-1:3,67,106:9,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:1" +
"0,93:2,68,106:3,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:10,93:2,10" +
"6:2,71,106,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:8,72,106,93:2,1" +
"06:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106,73,106:3,97,106:4,93:" +
"2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:4,74,106:5,93:2,10" +
"6:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:4,75,106:5,93:2,106:4," +
"93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:3,76,106:6,93:2,106:4,93:2" +
",106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:8,77,106,93:2,106:4,93:2,106:6" +
",-1:8,93:2,106:2,-1:13,106,93,-1:3,106:4,78,106:5,93:2,106:4,93:2,106:6,-1:" +
"8,93:2,106:2,-1:13,106,93,-1:3,106:10,93,79,106:4,93:2,106:6,-1:8,93:2,106:" +
"2,-1:13,106,93,-1:3,106:10,93:2,106:4,93,79,106:6,-1:8,93:2,106:2,-1:13,106" +
",93,-1:3,106:10,93:2,106:4,93:2,106,79,106:4,-1:8,93:2,106:2,-1:13,106,93,-" +
"1:3,106:10,93:2,106:4,93:2,106:5,84,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:2" +
",98,106:2,85,106:4,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3," +
"106:6,99,106:3,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:" +
"5,100,106,86,106:2,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3," +
"106:8,101,106,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,102,1" +
"06:9,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:3,87,106:6" +
",93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:5,100,106:4,93" +
":2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:10,88,93,106:4,89" +
",93,106:6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:10,93:2,106:3,103,93:2,106:" +
"6,-1:8,93:2,106:2,-1:13,106,93,-1:3,106:4,104,106:5,93:2,106:4,93:2,106:6,-" +
"1:8,93:2,106:2,-1:13,106,93,-1:3,106:5,105,106:4,93:2,106:4,93:2,106:6,-1:8" +
",93:2,106:2,-1:13,106,93,-1:3,106:6,90,106:3,93:2,106:4,93:2,106:6,-1:8,93:" +
"2,106:2,-1:13,106,93,-1:3,106:10,93:2,106:4,89,93,106:6,-1:8,93:2,106:2,-1:" +
"13,106,93,-1:3,106:4,94,106:5,93:2,106:4,93:2,106:6,-1:8,93:2,106:2,-1:13,1" +
"06,93,-1:2");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

  return new Symbol(sym.EOF, null);
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -3:
						break;
					case 3:
						{
	return new Symbol(sym.INTEGER, new LongToken(yytext(), yyline, yychar));
}
					case -4:
						break;
					case 4:
						{
	return new Symbol(sym.SEMICOLON, new StringToken(yytext(), yyline, yychar));
}
					case -5:
						break;
					case 5:
						{ 
	return new Symbol(sym.COMMA, new StringToken(yytext(), yyline, yychar));
}
					case -6:
						break;
					case 6:
						{
	return new Symbol(sym.LBRACE, new StringToken(yytext(), yyline, yychar));
}
					case -7:
						break;
					case 7:
						{
	return new Symbol(sym.RBRACE, new StringToken(yytext(), yyline, yychar));
}
					case -8:
						break;
					case 8:
						{
	return new Symbol(sym.LBRACKET, new StringToken(yytext(), yyline, yychar));
}
					case -9:
						break;
					case 9:
						{
	return new Symbol(sym.RBRACKET, new StringToken(yytext(), yyline, yychar));
}
					case -10:
						break;
					case 10:
						{
	return new Symbol(sym.LPAREN, new StringToken(yytext(), yyline, yychar));
}
					case -11:
						break;
					case 11:
						{
	return new Symbol(sym.RPAREN, new StringToken(yytext(), yyline, yychar));
}
					case -12:
						break;
					case 12:
						{
	System.out.println("Unmatched input: " + yytext());
  	return new Symbol(sym.error, new StringToken(yytext(), yyline, yychar));
}
					case -13:
						break;
					case 13:
						{ }
					case -14:
						break;
					case 14:
						{
	return new Symbol(sym.PLUS, new StringToken(yytext(), yyline, yychar));
}
					case -15:
						break;
					case 15:
						{
	return new Symbol(sym.MINUS, new StringToken(yytext(), yyline, yychar));
}
					case -16:
						break;
					case 16:
						{
	return new Symbol(sym.MULT, new StringToken(yytext(), yyline, yychar));
}
					case -17:
						break;
					case 17:
						{
	return new Symbol(sym.DIV, new StringToken(yytext(), yyline, yychar));
}
					case -18:
						break;
					case 18:
						{
	return new Symbol(sym.LT, new StringToken(yytext(), yyline, yychar));
}
					case -19:
						break;
					case 19:
						{
	return new Symbol(sym.GT, new StringToken(yytext(), yyline, yychar));
}
					case -20:
						break;
					case 20:
						{
	return new Symbol(sym.EQ, new StringToken(yytext(), yyline, yychar));
}
					case -21:
						break;
					case 21:
						{
	return new Symbol(sym.NOT, new StringToken(yytext(), yyline, yychar));
}
					case -22:
						break;
					case 22:
						{
	return new Symbol(sym.AND, new StringToken(yytext(), yyline, yychar));
}
					case -23:
						break;
					case 23:
						{
	return new Symbol(sym.OR, new StringToken(yytext(), yyline, yychar));
}
					case -24:
						break;
					case 24:
						{
	return new Symbol(sym.IF, new StringToken(yytext(), yyline, yychar));
}
					case -25:
						break;
					case 25:
						{
	String s = yytext();
	s = s.substring(1, s.length());		// remove quote at beginning
	s = s.substring(0,s.length()-1);	// remove quote at end
  	return new Symbol(sym.STRING_VALUE, new StringToken(s, yyline, yychar));
}
					case -26:
						break;
					case 26:
						{
	return new Symbol(sym.INCREMENT, new StringToken(yytext(), yyline, yychar));
}
					case -27:
						break;
					case 27:
						{
	return new Symbol(sym.DECREMENT, new StringToken(yytext(), yyline, yychar));
}
					case -28:
						break;
					case 28:
						{
	//System.out.println("Entering PARCOMMENT");
  	yybegin(PARCOMMENT);
}
					case -29:
						break;
					case 29:
						{
	yybegin(LINECOMMENT);
}
					case -30:
						break;
					case 30:
						{
	return new Symbol(sym.LTE, new StringToken(yytext(), yyline, yychar));
}
					case -31:
						break;
					case 31:
						{
	return new Symbol(sym.GTE, new StringToken(yytext(), yyline, yychar));
}
					case -32:
						break;
					case 32:
						{
	return new Symbol(sym.EQEQ, new StringToken(yytext(), yyline, yychar));
}
					case -33:
						break;
					case 33:
						{
	return new Symbol(sym.NEQ, new StringToken(yytext(), yyline, yychar));
}
					case -34:
						break;
					case 34:
						{
	return new Symbol(sym.LOGICAL_AND, new StringToken(yytext(), yyline, yychar));
}
					case -35:
						break;
					case 35:
						{
	return new Symbol(sym.LOGICAL_OR, new StringToken(yytext(), yyline, yychar));
}
					case -36:
						break;
					case 36:
						{
	return new Symbol(sym.FLOAT32, new FloatToken(yytext(), yyline, yychar));
}
					case -37:
						break;
					case 37:
						{
	return new Symbol(sym.FOR, new StringToken(yytext(), yyline, yychar));
}
					case -38:
						break;
					case 38:
						{
	return new Symbol(sym.ELSE, new StringToken(yytext(), yyline, yychar));
}
					case -39:
						break;
					case 39:
						{
	String typeName = yytext().toUpperCase();
	if (typeName.endsWith("_T")) typeName = typeName.substring(0, typeName.length()-2);
	return new Symbol(sym.VAR_TYPE, new TypeToken(DataType.valueOf(typeName), yyline, yychar));
}
					case -40:
						break;
					case 40:
						{
	return new Symbol(sym.SEND, new StringToken(yytext(), yyline, yychar));
}
					case -41:
						break;
					case 41:
						{
	return new Symbol(sym.BIND, new StringToken(yytext(), yyline, yychar));
}
					case -42:
						break;
					case 42:
						{
	return new Symbol(sym.WHILE, new StringToken(yytext(), yyline, yychar));
}
					case -43:
						break;
					case 43:
						{
  return new Symbol(sym.RETURN, new StringToken(yytext(), yyline, yychar));
}
					case -44:
						break;
					case 44:
						{
	return new Symbol(sym.INVOKE, new StringToken(yytext(), yyline, yychar)); 
}
					case -45:
						break;
					case 45:
						{
  return new Symbol(sym.REQUIRE, new StringToken(yytext(), yyline, yychar));
}
					case -46:
						break;
					case 46:
						{ }
					case -47:
						break;
					case 47:
						{
	yybegin(YYINITIAL);			// am I allowed to do this??
}
					case -48:
						break;
					case 48:
						{ }
					case -49:
						break;
					case 49:
						{
	//System.out.println("Entering YYINITIAL");
	yybegin(YYINITIAL);
}
					case -50:
						break;
					case 51:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -51:
						break;
					case 52:
						{
	return new Symbol(sym.INTEGER, new LongToken(yytext(), yyline, yychar));
}
					case -52:
						break;
					case 53:
						{
	System.out.println("Unmatched input: " + yytext());
  	return new Symbol(sym.error, new StringToken(yytext(), yyline, yychar));
}
					case -53:
						break;
					case 54:
						{ }
					case -54:
						break;
					case 56:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -55:
						break;
					case 58:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -56:
						break;
					case 60:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -57:
						break;
					case 62:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -58:
						break;
					case 63:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -59:
						break;
					case 64:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -60:
						break;
					case 65:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -61:
						break;
					case 66:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -62:
						break;
					case 67:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -63:
						break;
					case 68:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -64:
						break;
					case 69:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -65:
						break;
					case 70:
						{
	return new Symbol(sym.INTEGER, new LongToken(yytext(), yyline, yychar));
}
					case -66:
						break;
					case 71:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -67:
						break;
					case 72:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -68:
						break;
					case 73:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -69:
						break;
					case 74:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -70:
						break;
					case 75:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -71:
						break;
					case 76:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -72:
						break;
					case 77:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -73:
						break;
					case 78:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -74:
						break;
					case 79:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -75:
						break;
					case 80:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -76:
						break;
					case 81:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -77:
						break;
					case 82:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -78:
						break;
					case 83:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -79:
						break;
					case 84:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -80:
						break;
					case 85:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -81:
						break;
					case 86:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -82:
						break;
					case 87:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -83:
						break;
					case 88:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -84:
						break;
					case 89:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -85:
						break;
					case 90:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -86:
						break;
					case 91:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -87:
						break;
					case 92:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -88:
						break;
					case 93:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -89:
						break;
					case 94:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -90:
						break;
					case 95:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -91:
						break;
					case 96:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -92:
						break;
					case 97:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -93:
						break;
					case 98:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -94:
						break;
					case 99:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -95:
						break;
					case 100:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -96:
						break;
					case 101:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -97:
						break;
					case 102:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -98:
						break;
					case 103:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -99:
						break;
					case 104:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -100:
						break;
					case 105:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -101:
						break;
					case 106:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -102:
						break;
					case 107:
						{
  	return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar));
}
					case -103:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
