package servilla.compiler;

/**
 * A token containing a String value. This token is created by the
 * scanner (Yylex), and passed within Symbol objects to the parser 
 * (ServiceSpecParser).
 * 
 * @author Chien-Liang Fok
 */
public class StringToken extends Token {
    private String text;
    
    public StringToken(String text, int lineBegin, int charBegin) {
    	super(lineBegin, charBegin);
    	this.text = text;
    }
    
	public String text() {
    	return text;
    }
    
    public String toString() {
    	return super.toString() + ", text: " + text;
    }
}
