package servilla.compiler;

import servilla.service.tree.DataType;

/**
 * A token containing a single type value. This token is created by the
 * scanner (Yylex), and passed within Symbol objects to the parser 
 * (ServiceSpecParser).
 * 
 * @author Chien-Liang Fok <liangfok@wustl.edu>
 *
 */
public class TypeToken extends Token {
    private DataType type;
    
    public TypeToken(DataType type, int lineBegin, int charBegin) {
    	super(lineBegin, charBegin);
    	this.type = type;
    }
    
    public DataType type() {
      return type;
    }
    
    public String toString() {
      return super.toString() + ", type: " + type;
    }
}
