package servilla.compiler.tree;

/**
 * Defines the various types of binding.
 * 
 * @author Chien-Liang Fok
 *
 */
public enum BindType {
	// 1st bit: Lazy (0) or Eager (2)
	// 2nd bit: Transient (0) or Persistent (4)
	LAZY((byte)0), EAGER((byte)2), TRANSIENT((byte)0), PERSISTENT((byte)4);
	
	private byte value;
	
	BindType(byte value) { this.value = value; }
	
	public byte value() { return value; }
	
	public static void main(String[] args) {

		BindType[] v = BindType.values();
		System.out.println("// This was automatically generated by servilla.compiler.tree.BindType");
		System.out.println("// Copy this into types/Service.h");
		System.out.println("// Total # bind types: " + v.length);
		System.out.println("typedef enum {");
		for (int i = 0; i < v.length; i++) {
			System.out.println("\t" + v[i] + " = "+ v[i].value() + ",");
		}
		System.out.println("} ServiceBindType_t;");	
	}
	
}
