package servilla.compiler.tree;

/**
 * An invoke statement invokes a service.
 * 
 * @author Chien-Liang Fok
 *
 */
public class InvokeStatement extends Statement {
	private InvokeExpr expr;
	
	public InvokeStatement(InvokeExpr expr, int lineno, int charno) {
		super(lineno, charno);
		this.expr = expr;
	}

	public void assemble(CodeWriter cw) throws AssemblerException {
		expr.assemble(cw);
		popRetVal(cw, expr, "Discard result of invoke expr");
	}
	
	public String toString() {
		return "(INVOKE: " + expr + ")";
	}

	@Override
	public long initAddr(long startAddr) {
		return expr.initAddr(startAddr);
	}
	
	@Override
	public long localVarSize() {
		return expr.localVarSize();
	}
}
