package servilla.compiler.tree;

/**
 * Implements an expression surrounded by parenthesis. 
 * 
 * @author Chien-Liang Fok
 */
public class ParenExpr extends Expr {
	private Expr expr;
	
	public ParenExpr(Expr expr, int lineno, int charno) {
		super(lineno, charno);
		this.expr = expr;
	}
	
	@Override
	public Type retType(CodeWriter cw) throws AssemblerException { return expr.retType(cw); }

	@Override
	public int retHeapSize(CodeWriter cw) throws AssemblerException { return expr.retHeapSize(cw); }
	
	public void assemble(CodeWriter cw) throws AssemblerException { expr.assemble(cw); }
	
	public String toString() { return "(ParenExpr " + expr.toString() + ")"; }

	@Override
	public long initAddr(long startAddr) { return expr.initAddr(startAddr); }

	@Override
	public int retStackSize(CodeWriter cw) throws AssemblerException { return expr.retStackSize(cw); }

	@Override
	public long localVarSize() { return expr.localVarSize(); }
}
