package servilla.msgs.reliable;

import java.util.*;
import servilla.msgs.ServillaStateMsg;
import servilla.util.ByteUtils;
import org.apache.commons.lang.ArrayUtils;

public class ServillaStateMsgJ {
	int id;
	long codeSize, servSize, sp;
	short op;
	long pc, init_sp, fp;
	int cond;
	
	public ServillaStateMsgJ(int id, long codeSize, long servSize, long sp, short op, long pc, long init_sp, long fp, int cond) {
		this.id = id;
		this.codeSize = codeSize;
		this.servSize = servSize;
		this.sp = sp;
		this.op = op;
		this.pc = pc;
		this.init_sp = init_sp;
		this.fp = fp;
		this.cond = cond;
	}
	
	public short amType() { return ServillaStateMsg.AM_TYPE; }
	
	public byte[] toByteArray() {
		Vector<Byte> bv = new Vector<Byte>();
		ByteUtils.saveBytes2(bv, id);
		ByteUtils.saveBytes4(bv, codeSize);
		ByteUtils.saveBytes4(bv, servSize);
		ByteUtils.saveBytes4(bv, sp);
		ByteUtils.saveBytes1(bv, op);
		ByteUtils.saveBytes4(bv, pc);
		ByteUtils.saveBytes4(bv, init_sp);
		ByteUtils.saveBytes4(bv, fp);
		ByteUtils.saveBytes2(bv, cond);
		return ArrayUtils.toPrimitive(bv.toArray(new Byte[]{}));
	}
	
	public String toString() {
		StringBuffer result = new StringBuffer();
		result.append("ServillaStateMsg: \n");
		result.append("\tid="+id+"\n");
		result.append("\tcodeSize="+codeSize+"\n");
		result.append("\tservSize="+servSize+"\n");
		result.append("\tsp="+sp+"\n");
		result.append("\top="+op+"\n");
		result.append("\tpc="+pc+"\n");
		result.append("\tinit_sp="+init_sp+"\n");
		result.append("\tfp="+fp+"\n");
		result.append("\tcond="+cond+"\n");
		return result.toString();
	}
}
