package servilla.service;

/**
 * A token containing a single float value. This token is created by the
 * scanner (Yylex), and passed within Symbol objects to the parser 
 * (ServiceSpecParser).
 * 
 * @author Chien-Liang Fok <liangfok@wustl.edu>
 *
 */
public class FloatToken extends Token {
    private float value;
    
    public FloatToken(String text, int lineBegin, int charBegin) {
    	super(lineBegin, charBegin);
    	this.value = new Float(text).floatValue();
    }
    
    public float value() {
      return value;
    }
    
    public String toString() {
      return super.toString() + ", float: " + value;
    }
}