package servilla.service;

/**
 * A token containing a single integer value. This token is created by the
 * scanner (Yylex), and passed within Symbol objects to the parser 
 * (ServiceSpecParser).
 * 
 * @author Chien-Liang Fok
 *
 */
public class IntToken extends Token {
    private long value;
    
    public IntToken(String text, int lineBegin, int charBegin) {
    	super(lineBegin, charBegin);
    	this.value = new Long(text).longValue();
    }
    
    public long value() {
      return value;
    }
    
    public String toString() {
      return super.toString() + ", IntToken: " + value;
    }
}