package servilla.service;

import java_cup.runtime.*;

%%

%implements java_cup.runtime.Scanner
%function next_token
%type java_cup.runtime.Symbol

%eofval{
  return new Symbol(sym.EOF, null);
%eofval}

%{
  public String sourceFilename;
%}

%class ServiceSpecYylex

%line
%char
%state LINECOMMENT, PARCOMMENT, STRING

ALPHA=[%A-Za-z_]
DIGIT=[0-9]
FILECHAR=[./:]
ALPHA_NUMERIC={ALPHA}|{DIGIT}|"-"

NAME="NAME"
ATTRIBUTE="ATTRIBUTE"
INPUT="INPUT"
OUTPUT="OUTPUT"


INT16_T="int16_t"// This was generated by servilla.service.tree.DataType
UINT16_T="uint16_t"
INT32_T="int32_t"
UINT32_T="uint32_t"
FLOAT32_T="float32_t"
STRING_T="string_t"

STRING={ALPHA}({ALPHA_NUMERIC})*
INTEGER=-?({DIGIT})+
FLOAT=-?({DIGIT})+(.{DIGIT}+)
WHITE_SPACE=([\ \n\r\t\f])
EQ="="
LBRACKET=\x5B
RBRACKET=\x5D
LBRACE=\x7B
RBRACE=\x7D
COMMA=","
QUOTE=\"

EQ="=" // This was generated by servilla.service.tree.Relation
LT="<"
GT=">"
LTE="<="
GTE=">="

%%

<YYINITIAL> {LBRACE} { return new Symbol(sym.LBRACE, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {RBRACE} { return new Symbol(sym.RBRACE, new StringToken(yytext(), yyline, yychar)); }

<YYINITIAL> {LBRACKET} { return new Symbol(sym.LBRACKET, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {RBRACKET} { return new Symbol(sym.RBRACKET, new StringToken(yytext(), yyline, yychar)); }


<YYINITIAL> {NAME} { return new Symbol(sym.NAME, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {ATTRIBUTE} { return new Symbol(sym.ATTRIBUTE, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {INPUT} { return new Symbol(sym.INPUT, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {OUTPUT} { return new Symbol(sym.OUTPUT, new StringToken(yytext(), yyline, yychar)); }

<YYINITIAL> {INT16_T} { return new Symbol(sym.INT16_T, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {UINT16_T} { return new Symbol(sym.UINT16_T, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {INT32_T} { return new Symbol(sym.INT32_T, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {UINT32_T} { return new Symbol(sym.UINT32_T, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {FLOAT32_T} { return new Symbol(sym.FLOAT32_T, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {STRING_T} { return new Symbol(sym.STRING_T, new StringToken(yytext(), yyline, yychar)); }

<YYINITIAL> {STRING} { return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {QUOTE} { yybegin(STRING); }
<STRING> {QUOTE} { yybegin(YYINITIAL); }
<STRING> [^\"]* { return new Symbol(sym.STRING, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {INTEGER} { return new Symbol(sym.INTEGER, new IntToken(yytext(), yyline, yychar)); }
<YYINITIAL> {FLOAT} { return new Symbol(sym.FLOAT, new FloatToken(yytext(), yyline, yychar)); }

<YYINITIAL> {EQ} { return new Symbol(sym.EQ, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {LT} { return new Symbol(sym.LT, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {GT} { return new Symbol(sym.GT, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {LTE} { return new Symbol(sym.LTE, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {GTE} { return new Symbol(sym.GTE, new StringToken(yytext(), yyline, yychar)); }

<YYINITIAL> {COMMA} { return new Symbol(sym.COMMA, new StringToken(yytext(), yyline, yychar)); }
<YYINITIAL> {WHITE_SPACE} { }

<YYINITIAL> "//" { yybegin(LINECOMMENT); }
<LINECOMMENT> [^\n] { }
<LINECOMMENT> [\n] { yybegin(YYINITIAL); }

<YYINITIAL> "/*" { yybegin(PARCOMMENT); }
<PARCOMMENT> [^"*/"] { }
<PARCOMMENT> "*" { }
<PARCOMMENT> "*/" { yybegin(YYINITIAL); }

<YYINITIAL> . {  return new Symbol(sym.error, new StringToken(yytext(), yyline, yychar)); }

