package servilla.service;

/**
 * This is the token created by the scanner.  See its subclasses for the specific types of 
 * tokens.
 * 
 * @author Chien-Liang Fok <liangfok@wustl.edu>
 */
public abstract class Token {
	public int lineBegin;
	public int charBegin;

	Token() {}

	Token(int lineBegin, int charBegin) {
		this.lineBegin = lineBegin + 1;
		this.charBegin = charBegin;
	}

	public String toString() {
		return "line: " + lineBegin + ", char: " + charBegin;
	}

	public int lineno() {
		return lineBegin;
	}

	public int charno() {
		return charBegin;
	}
}