package servilla.service.tree;

/**
 * Defines the various types of properties.  The byte value associated 
 * with each PropertyType must match that in servilla/components/SPF/Service.h.
 *  
 * @author Chien-Liang Fok <liangfok@wustl.edu>
 *
 */
public enum PropertyType {
	NAME,
	ATTRIBUTE,
	INPUT, 
	OUTPUT;
	
	static byte counter = 0;
	
	private byte value;
	
	
	static byte nextCount() {
		return (byte)counter++;
	}
	
	PropertyType() {
		this.value = PropertyType.nextCount();
	}
	
	public byte value() {
		return value;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

		PropertyType[] v = PropertyType.values();
		System.out.println("// This was automatically generated by servilla.service.tree.PropertyType");
		System.out.println("// Copy this into types/Service.h");
		System.out.println("// Total # property types: " + v.length);
		System.out.println("typedef enum {");
		for (int i = 0; i < v.length; i++) {
			System.out.println("\tPROP_" + v[i] + " = "+ v[i].value() + ",");
		}
		System.out.println("} ServicePropertyType_t;");	
	}
}
