package servilla.service.tree;

import java.util.*;
import org.apache.commons.lang.ArrayUtils;

/**
 * A super class of all values.
 *
 * @author Chien-Liang Fok
 */
public abstract class Value {
	
	/**
	 * Returns the type of the value.
	 * 
	 * @return the type of the value.
	 */
	public abstract DataType type();
	
	/**
	 * Converts the value into its byte representation.
	 * 
	 * @return The byte representation of the Value.
	 */
	public abstract Vector<Byte> toByteVector();
	
	public byte[] toByteArray() {
		return ArrayUtils.toPrimitive(toByteVector().toArray(new Byte[]{}));
	}
	
}