package servilla.util;

import java.io.*;
public class CompileErrorUtils {

	/**
	 * Prints the line that caused the error and an arrow indicating
	 * where the error occured.
	 *
	 * @param programText The program being compiled.
	 * @param lineno The line number.
	 * @param charo The character number starting from the first character in 
	 * the program text.
	 */
	public static String getErrorLine(String text, int lineno, int charno) {
		String result = "[ERROR: Unable to get error line]";
		try {
			BufferedReader br = new BufferedReader(new StringReader(text));
			int numChars = 0;
			int numLines = 0;
			String cLine = "";
			while (numLines < lineno) {
				cLine = br.readLine();
				if (numLines < lineno -1) numChars += cLine.length();
				numLines++;
			}
			byte[] ba = text.getBytes();
			int numTabs = 0;
			for (int i = numChars; i < charno; i++) {
				if (ba[i] == (byte)0x09) numTabs++;
			}
			int numSpaces = (charno - numChars) - numTabs;
			String spaces = "";
			for (int i = 0; i < numSpaces; i++) {
				spaces += " ";
			}
			for (int i = 0; i < numTabs; i++) {
				spaces += "\t";
			}
			result = cLine + "\n" + spaces + "^";
		} catch(IOException e) {
			e.printStackTrace();
		}
		return result;
	}
}
