package servilla.util;

import java.util.*;

/**
 * This contains some methods for converting one type of vector to another.
 * @author Chien-Liang Fok
 */
public class VectorUtils {
	
	/**
	 * Converts a vector of bytes into a vector of strings.  The strings
	 * are the bytes in hex notation.
	 * 
	 * @param bv The vector of bytes.
	 * @return The vector of Strings.
	 */
	public static Vector<String> toStringVector(Vector<Byte> bv) {
		Vector<String> result = new Vector<String>(bv.size());
		for (int i = 0; i < bv.size(); i++) {
			result.add(ArrayToHexString.byteToHexString(bv.get(i)));
		}
		return result;
	}
}
